﻿using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;
using MacGruber;
using customevent;
using MVR.FileManagementSecure;
using Random = System.Random;
using Random2 = UnityEngine.Random;

/*

V6:
- NEW: added new expired functionality, a second trigger that gets triggered after X seconds pass with no other collision of the same type happening
- NEW: added screenshots to presets
- FIX: trigger not detecting collision when atom containing it is inside a CollisionTrigger atom
- CHANGE: reorganized UI to make it one-page no-scroll
V7: Added AliveExtraTriggers
*/

namespace SPQR
{
    public class ExtraTriggers : MVRScript
    {
		

        private bool gameIsVR;
		private EventTrigger myEventTrigger;
		private EventTrigger myEventTrigger2;
		
        GameObject playerHands;
        float collisionThreshold = 0.05f;
		float collisionCooldown = 1f;
		float expireDefault = 3f;
		JSONStorableFloat treshold1;
		JSONStorableFloat treshold2;
		JSONStorableFloat jfloat2;
		JSONStorableFloat expired;

		string SavePath = "Saves\\PluginData\\ExtraTriggers";
        string SaveExtension = "json";
		
		private float myClock = -1.0f;
		
		private float expireTime = -1f;

		int titles = 0;
        protected JSONStorableString myString;

		Dictionary<string, JSONStorableBool> enableFeatures = new Dictionary<string, JSONStorableBool>();

		JSONStorableString variableThisElement;
		JSONStorableString variableColliderGroup;
		JSONStorableString variableColliderId;
		JSONStorableString variableColliderElement;
		
		
		string[] variableThisElements;
		string[] variableColliderGroups;
		string[] variableColliderIds;
		string[] variableColliderElements;
		
		JSONStorableString collisionsLog;
		JSONStorableBool collisionsLogBool;
		
		JSONStorableString collisionsPreview;
		UIDynamicTextField dtext4;

		Dictionary<string, UIDynamicButton> buttons = new Dictionary<string, UIDynamicButton>();

		public void updateVariables(){
			
			if(variableThisElement.val.Trim() == "")
				variableThisElements = new string[0];
			else 
				variableThisElements =  variableThisElement.val.Split('|').Select(k => k.Trim()).ToArray();
			
			if(variableColliderGroup.val.Trim() == "")
				variableColliderGroups = new string[0];
			else 
				variableColliderGroups = variableColliderGroup.val.Split('|').Select(k => k.Trim()).ToArray();
			
			if(variableColliderId.val.Trim() == "")
				variableColliderIds = new string[0];
			else 
				variableColliderIds = variableColliderId.val.Split('|').Select(k => k.Trim()).ToArray();
			
			if(variableColliderElement.val.Trim() == "")
				variableColliderElements = new string[0];
			else 
				variableColliderElements = variableColliderElement.val.Split('|').Select(k => k.Trim()).ToArray();
			
		}

        public override void Init()
        {
            Utils.OnInitUI(CreateUIElement);
            gameIsVR = XRSettings.isDeviceActive && !string.IsNullOrEmpty(XRSettings.loadedDeviceName);

			
			
			// JSONStorableString logo = new JSONStorableString("logostring", "\n<size=40><b>ExtraTriggers</b></size>");
            // UIDynamicTextField logotext = CreateTextField(logo);
            // logotext.UItext.supportRichText = true;
            // logotext.backgroundColor = new Color(0f, 0f, 0f, 0f);
            // logotext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            // logotext.height = 60f;
            // logotext.UItext.alignment = TextAnchor.UpperLeft;


            // JSONStorableString logor = new JSONStorableString("logospace", "\n<size=30><b>v6.0</b></size>");
            // UIDynamicTextField logortext = CreateTextField(logor, true);
            // logortext.UItext.supportRichText = true;
            // logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
            // logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
            // logortext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            // logortext.height = 60f;
            // logortext.UItext.alignment = TextAnchor.UpperRight;

            // Utils.SetupSpacer(this, 10, false);
            // Utils.SetupSpacer(this, 10, true);

	
			CreateTitle("THIS ATOM",35,false);
			
			variableThisElement = new JSONStorableString("Element:", "", UpdateVarValue);
            variableThisElement.storeType = JSONStorableParam.StoreType.Full;
			RegisterString(variableThisElement);
			Utils.SetupTextInput(this, "Element ", variableThisElement, false);
			

			CreateTitle("COLLIDED ATOM",35,false);
			
			variableColliderGroup = new JSONStorableString("Collider Group","", UpdateVarValue);
            variableColliderGroup.storeType = JSONStorableParam.StoreType.Full;
			RegisterString(variableColliderGroup);
			Utils.SetupTextInput(this, "Group ", variableColliderGroup, false);
			
			variableColliderId = new JSONStorableString("Collider Atom","", UpdateVarValue);
            variableColliderId.storeType = JSONStorableParam.StoreType.Full;
			RegisterString(variableColliderId);
			Utils.SetupTextInput(this, "Atom Name", variableColliderId, false);
			
			variableColliderElement = new JSONStorableString("Collider Element","", UpdateVarValue);
            variableColliderElement.storeType = JSONStorableParam.StoreType.Full;
			RegisterString(variableColliderElement);
			Utils.SetupTextInput(this, "Element ", variableColliderElement, false);
			
			
			Utils.SetupSpacer(this, 66, false);
			
			collisionsLogBool = new JSONStorableBool("Enable log", true);
            collisionsLogBool.storeType = JSONStorableParam.StoreType.Full;
			RegisterBool(collisionsLogBool);
			CreateToggle(collisionsLogBool, false);
				
			collisionsLog = new JSONStorableString("collisionsLog", "");
            collisionsLog.storeType = JSONStorableParam.StoreType.Full;
            UIDynamicTextField dtext3 = CreateTextField(collisionsLog, false);
            dtext3.UItext.supportRichText = true;
            dtext3.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext3.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext3.height = 550f;
			
			treshold1 = new JSONStorableFloat("Treshold Min", 0.05f, BlendCallback, 0f, 10f, true);
            treshold1.storeType = JSONStorableParam.StoreType.Full;
			RegisterFloat(treshold1);
			UIDynamicSlider dslider = CreateSlider(treshold1,true);
			
			treshold2 = new JSONStorableFloat("Treshold Max", 10f, BlendCallback, 0f, 10f, true);
            treshold2.storeType = JSONStorableParam.StoreType.Full;
			RegisterFloat(treshold2);
			UIDynamicSlider dslider2 = CreateSlider(treshold2,true);
			
			jfloat2 = new JSONStorableFloat("Cooldown", collisionCooldown, BlendCallback, 0f, 10f, true);
            jfloat2.storeType = JSONStorableParam.StoreType.Full;
			RegisterFloat(jfloat2);
			UIDynamicSlider dslider3 = CreateSlider(jfloat2,true);

			
			expired = new JSONStorableFloat("Expire", expireDefault, BlendCallback, 0f, 10f, true);
            expired.storeType = JSONStorableParam.StoreType.Full;
			RegisterFloat(expired);
			UIDynamicSlider dslider4 = CreateSlider(expired,true);
	
			myEventTrigger = new EventTrigger(this, "TriggerOnUpdate");
            Utils.SetupButton(this, "Trigger On Collision", myEventTrigger.OpenPanel, true);

			myEventTrigger2 = new EventTrigger(this, "TriggerOnExpire");
            Utils.SetupButton(this, "Trigger On Expire", myEventTrigger2.OpenPanel, true);

            Utils.SetupButton(this, "Test Trigger", TestTrigger, true);
            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
			
			
			collisionsPreview = new JSONStorableString("collisionsPreview", "PREVIEW: NOT HIT");
		    dtext4 = CreateTextField(collisionsPreview, true);
            dtext4.UItext.supportRichText = true;
            dtext4.backgroundColor = new Color(1f, 0.33f, 0.33f, 0.7f);
            dtext4.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext4.height = 100f;

			buttons.Add("load_preset", CreateButton("Load Preset",true));
                buttons["load_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(SavePath);
                    var shortcuts = FileManagerSecure.GetShortCutsForDirectory(SavePath);
                    SuperController.singleton.GetMediaPathDialog(HandleLoadPreset, SaveExtension, SavePath, false, true, false, null, false, shortcuts);
                });

                buttons.Add("save_preset", CreateButton("Save Preset", true));
                buttons["save_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(SavePath);
                    var fileBrowserUI = SuperController.singleton.fileBrowserUI;
                    fileBrowserUI.SetTitle("Save preset");
                    fileBrowserUI.fileRemovePrefix = null;
                    fileBrowserUI.hideExtension = true;
                    fileBrowserUI.keepOpen = false;
                    fileBrowserUI.canCancel = true;
                    fileBrowserUI.fileFormat = SaveExtension;
                    fileBrowserUI.defaultPath = SavePath;
                    fileBrowserUI.showDirs = true;
                    fileBrowserUI.showFiles = true;
                    fileBrowserUI.shortCuts = null;
                    fileBrowserUI.browseVarFilesAsDirectories = false;
                    fileBrowserUI.SetTextEntry(true);
                    fileBrowserUI.Show(HandleSavePreset);
                    fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + SaveExtension;
                    fileBrowserUI.ActivateFileNameField();
                });



            // JSONStorableString jstring = new JSONStorableString("instructions1", "\n This plugin allows setting collision triggers for the elements of the atom that has it.");
            // UIDynamicTextField dtext = CreateTextField(jstring, false);
            // dtext.UItext.supportRichText = true;
            // dtext.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
            // dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
            // dtext.height = 200f;

             
            JSONStorableString jstring2 = new JSONStorableString("instructions2", 
			"\n <b>ExtraTriggers V8</b>\n"+
			"\n This plugin allows setting collision triggers for the elements of the atom that has it.\n"+
			"\n<b>Logged collision format:</b> \n Element1 collision (Strength) with \n Group2:Atom2:Element2 \n \n"+
			"Element1 is the part of this atom that collided with something.\n\n"+
			"Group2 is the type of atom it collided with. Atom2 is the atom name it collided with. Element2 is what part of an atom it collided with.\n\n"+
			" You can leave the optional fields empty. If you set values to them, they'll be used to filter the collisions. \n\n You can set multiple values separated by | (e.g. 'rThumb1|rThumb2|rThumb3' to capture all parts of the right thumb). \n\n"+
			"<b>Element</b> - this is the part of an atom that you're expecting to be hit. Leave empty if you want to capture the collision by the whole atom. \n"+
			"<b>Group</b> - Optional; this is the type of object you're expecting the element to get hit by (e.g. Person, Floor,Slate)  \n"+
			"<b>Atom</b> - Optional; this is the atom id or ids that you want to look for\n"+
			"<b>Collider</b> - Optional; this is a specific collider that you're looking for, for example the right hand of another person atom\n"+
			"\n\n"+
			"<b>Threshold</b> - How strong the collision must be to count \n"+
			"<b>Cooldown</b> - How many seconds of cooldown should pass before the next collision trigger is allowed \n\n"+
			"<b>Expired</b> - After how many seconds after the last collision the Expired trigger gets called. If a new collision happens the timer resets \n\n"+
			"<b>Trigger On Collision</b> - here is where you set what should happen when the collision is triggered\n"+
			"<b>Trigger On Expire</b> - here is where you set what should happen after the collision expires\n"
			);
            UIDynamicTextField dtext2 = CreateTextField(jstring2,true);
            dtext2.UItext.supportRichText = true;
            dtext2.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
            dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext2.height = 200f;




            SimpleTriggerHandler.LoadAssets();
            UIUpdate();
            updateVariables();
        }

        private void UIUpdate()
        {
        }
	

        void Start()
        {	
			RefreshColliders();
        }

        void Update()
        {
			myEventTrigger.Update();
			myEventTrigger2.Update();

			if(expireTime > -1 && expireTime < Time.time){
				TriggerExpired();
			}

			if (myClock < 0.0f)
				return;

			myClock -= Time.deltaTime;
        }

        void FixedUpdate()
        {
           
        }
		
		void OnEnable(){
			RefreshColliders();
			updateVariables();
		}

        void OnDisable()
        {
            containingAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
			{
				try{
				 f.gameObject.GetComponent<TriggerCollide>().OnCollide -= ObserveTrigger;
				} catch(Exception e){
					
				}
			});
        }
		void OnReload()
        {
            OnDisable();
        }
	    private void OnAtomRename(string oldid, string newid)
        {
            myEventTrigger.SyncAtomNames();
			myEventTrigger2.SyncAtomNames();
			if(variableColliderId.val == oldid){
				variableColliderId.val = newid;
			}
        }
		
		public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
		{
			JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
			if (includePhysical || forceStore)
			{
				needsStore = true;
				jc[myEventTrigger.Name] = myEventTrigger.GetJSON(base.subScenePrefix);
				jc[myEventTrigger2.Name] = myEventTrigger2.GetJSON(base.subScenePrefix);
			}
			return jc;
		}
		
		public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
		{
			base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);
			if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
			{
				myEventTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
				myEventTrigger2.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
			}
		}

        void OnDestroy()
        {
            Utils.OnDestroyUI();
            OnDisable();
			myEventTrigger.Remove();
			myEventTrigger2.Remove();
        }

	
		public void UpdateVarValue(string s){
			updateVariables();
		}	
		void BlendCallback(JSONStorableFloat jf){
		}
		
	    private void TestTrigger()
        {
           Trigger();

        }
        private void Trigger()
        {
            myEventTrigger.Trigger();
			expireTime = Time.time + expired.val;
        }
		private void TriggerExpired()
        {
			expireTime = -1f;
            myEventTrigger2.Trigger();

			collisionsPreview.val = "PREVIEW: EXPIRED";
			dtext4.backgroundColor = new Color(0.33f, 0.33f, 1f, 0.7f);
			StartCoroutine(CoroutineFlashTrigger());

        }

        public void RefreshColliders()
        {
			containingAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
			{
				try{
				 f.gameObject.GetComponent<TriggerCollide>().OnCollide += ObserveTrigger;
				} catch (Exception e){
					f.gameObject.AddComponent<TriggerCollide>().OnCollide += ObserveTrigger;
				}
			});
	
        }



        void ObserveTrigger(object sender, TriggerEventArgs e){
			
            Atom parent = null;
			if(myClock > 0f) return;
            foreach (var component in e.collider.gameObject.GetComponentsInParent<Component>())
            {

                var atom = component as Atom;
                if (atom != null)
                {
                    parent = atom;
                    break;
                }
            }
          
		


            var found = "";
            var components = e.collider.transform.parent.GetComponents<Component>();

            var RB = e.collider.attachedRigidbody;

            foreach (var xatom in SuperController.singleton.GetAtoms())
            {
                var RB2 = xatom.rigidbodies.First();
                if (RB == RB2)
                {
                    found = xatom.name;
                    break;
                }

            }
			
		//	SuperController.LogMessage("wtf1");

            if (e.evtType == customevent.EventType.HIT)
            {
                float level = e.collision.relativeVelocity.magnitude / 3.0f;
				//SuperController.LogMessage("collide at high level: " + level + ", threshold: " + collisionThreshold.val);
                if (level > treshold1.val && level < treshold2.val)
                {
                    //if (level > 3) level = 3;

                    //SuperController.LogMessage("collide at high level: " + level + ", threshold: " + collisionThreshold.val);
                   
						/*
						foreach(var contactpoint in e.collision.contacts){
							SuperController.LogMessage(contactpoint.thisCollider.attachedRigidbody.name + " with " + contactpoint.otherCollider.attachedRigidbody.name);
						}
						*/
						
                        var xname = found.Length > 0 ? found : parent.name;
                       var xcollider = e.collider.name;
					   if(e.collision.contacts.Count() > 0){
						xcollider = e.collision.contacts[0].otherCollider.attachedRigidbody.name;
					   }
					   	//SuperController.LogMessage("collide|"+Time.time +" "+xname+" "+parent.type+" "+xcollider+" "+level);
                        RaeClickTouch(sender.ToString(), xname, parent.type, xcollider, level);

                        //SuperController.LogMessage("!!!!!Receiving event " + parent.name + " of " + found + " of " + e.collider.name);
                        // SuperController.LogMessage("Collide with other object");

                }
                else
                { 
					
				}
            }
            else{}
			
        }


        //////////////////////////////////////////////



		void RaeClickTouch(string sender, string name, string type, string collider, float level){
			var slevel =  String.Format("{0:0.000}",level);
			sender = sender.Replace(" (customevent.TriggerCollide)","");
			if(name==containingAtom.name) return;
			if(collisionsLogBool.val){
				var s = ""+sender + " collision ("+slevel+") with:  \n" + type +":"+name+":"
				+collider + "\n\n" + collisionsLog.val;
				
				if(s.Length > 500){
					s = s.Substring(0,500);
				}
				collisionsLog.val = s;
				
			//	SuperController.LogMessage("Detected touch from "+sender+" with "+name+" - ("+type+")"+collider + "with level " +level);
				
			}
			
			if(variableThisElements.Count() > 0){
				if(!CheckInArrayValues(variableThisElements, sender)) return;
				//if(Array.IndexOf(variableThisElements, sender) == -1) return;
			}
			
			
			if(variableColliderGroups.Count() > 0){
				if(!CheckInArrayValues(variableColliderGroups, type)) return;
				//if(Array.IndexOf(variableColliderGroups, type) == -1) return;
			}
			
			if(variableColliderIds.Count() > 0){
				if(!CheckInArrayValues(variableColliderIds, name)) return;
				//if(Array.IndexOf(variableColliderIds, name) == -1) return;
			}
			
			
			if(variableColliderElements.Count() > 0){
				if(!CheckInArrayValues(variableColliderElements, collider)) return;
				//if(Array.IndexOf(variableColliderElements, collider) == -1) return;
			}
			
			
			
			collisionsPreview.val = "PREVIEW: HIT";
			dtext4.backgroundColor = new Color(0.33f, 1f, 0.33f, 0.7f);
			StartCoroutine(CoroutineFlashTrigger());
			myClock = jfloat2.val;
			Trigger();
			
		}
		
		
		private bool CheckInArrayValues(string[] arr, string val){
			var found = false;
			if(val=="") return found;
			if(val==" ") return found;
			foreach(var element in arr){
				//SuperController.LogMessage("check "+element+" vs " + val);
				if(val.Contains(element)) return true;
			}
			return found;
		}
		
		 private IEnumerator CoroutineFlashTrigger(){
		    yield return StartCoroutine(Wait(1f));
		    collisionsPreview.val = "PREVIEW: -";
			dtext4.backgroundColor = new Color(1f, 0.33f, 0.33f, 0.7f);
		 }
		 
		 
		IEnumerator Wait(float seconds)
		{
		yield return new WaitForSeconds(seconds);
		}

        void UpdateMyString(string name)
        {
        }

		private void CreateTitle(string text, int fontsize, bool right,int spacing){
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right){
                JSONStorableString title1 = new JSONStorableString("title"+(++titles), "\n<size="+fontsize+"><b>"+text+"</b></size>");
                UIDynamicTextField title1text = CreateTextField(title1, right);
                title1text.UItext.supportRichText = true;
                title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
                title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                title1text.height = 100f;
                title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

		
        private void HandleLoadPreset(string path)
        {
           if (path == null) return;
            var jc = (JSONClass)LoadJSON(path);
            base.RestoreFromJSON(jc);

			myEventTrigger.RestoreFromJSON(jc, base.subScenePrefix,false, true);
			myEventTrigger2.RestoreFromJSON(jc, base.subScenePrefix,false, true);
        }

        private void HandleSavePreset(string path)
        {
            SuperController.singleton.fileBrowserUI.fileFormat = null;
            if (path == null) return;
            var jc = GetJSON(true,true,true);
            SaveJSON(jc, path);
			SuperController.singleton.DoSaveScreenshot(path);
        }


     
        


    }



}
