using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using customeventET;
using MVR.FileManagementSecure;
using Random2 = System.Random;
using Random = UnityEngine.Random;


namespace SPQR
{

    public class UIworks
    {
        AliveTriggers X;


        string[] tabs_p67 = new string[] {  "Touch Detection", "Touch Triggers", "Stare Triggers","Status Triggers", "Presets" };
        public Dictionary<string, bool> tabsBool_p67 = new Dictionary<string, bool>();
        public Dictionary<string, UIDynamicButton> tabsButtons_p67 = new Dictionary<string, UIDynamicButton>();
        public Dictionary<string, UIDynamicButton> uiButtons_p67 = new Dictionary<string, UIDynamicButton>();

        public string[] tickletriggers_p67 = new string[] { "None", "Light", "Medium", "High", "MAX" };
        //public string[] areas_p67 = new string[] { "head", "neck", "chest", "abdomen", "thighs", "shoulders", "forearms", "hands", "shins", "feet", "hip", "breasts", "gens", "glutes" };
        public List<string> choicesMeters_p67 = new List<string>(new string[] { "None", "Light", "Medium", "High", "MAX" });



        public Dictionary<string, bool> traits_p67 = new Dictionary<string, bool>() {
            {"TongueKisser", true },
            {"Screamer", false },
            {"Shy", false },
            {"Diva", false},
            {"Happy", true},
            {"Sad", false},
            {"Angry", false},
        };



        public UIworks(AliveTriggers script)
        {
            X = script;
        }



        public void InitUI_p67()
        {




            X.jstring_p67 = new JSONStorableString("instructions1", "");
            X.jstring2_p67 = new JSONStorableString("instructions2", "");



            bool showUI = false;

            X.choosers_p67.Add("tease", new JSONStorableStringChooser("Teased", X.choicesMeters_p67, "None", "Teased"));

            X.choosers_p67.Add("arouse", new JSONStorableStringChooser("Arousal", X.choicesMeters_p67, "None", "Arousal"));

            X.choosers_p67.Add("pain", new JSONStorableStringChooser("Discomfort", X.choicesMeters_p67, "None", "Discomfort"));



            foreach (var itemtickledtrigger in X.tickletriggers_p67)
            {
                X.myEventTriggers_p67.Add("ontease" + itemtickledtrigger, new EventTrigger(X, "Trigger Tease " + itemtickledtrigger));
                X.myEventTriggers_p67.Add("oncaress" + itemtickledtrigger, new EventTrigger(X, "Trigger Arouse " + itemtickledtrigger));
                X.myEventTriggers_p67.Add("onspank" + itemtickledtrigger, new EventTrigger(X, "Trigger Discomfort " + itemtickledtrigger));              
            }


            //triggers
            X.collisionsLogBool_p67 = new JSONStorableBool("Enable log", false);
            X.AliveStatus_p67 = new JSONStorableString("AliveStatus", "");

            X.RegisterBool(X.collisionsLogBool_p67);



            X.collisionsLog_p67 = new JSONStorableString("collisionsLog", "");
            X.collisionsLog_p67.storeType = JSONStorableParam.StoreType.Full;


            X.sliders_p67.Add("treshold1", new JSONStorableFloat("Treshold Min", 0.05f, 0f, 10f, true));
            X.sliders_p67.Add("treshold2", new JSONStorableFloat("Treshold Max", 10f, 0f, 10f, true));
            X.sliders_p67.Add("cooldown", new JSONStorableFloat("Cooldown", X.collisionCooldown_p67, 0f, 10f, true));


            X.CreateTitle_p67("titlepluginname", "Alive Triggers", 40, false);

            foreach (var tab in tabs_p67)
            {
                tabsBool_p67[tab] = false;
                tabsButtons_p67[tab] = CreateTabButton_p67(tab, false);
                tabsButtons_p67[tab].button.onClick.AddListener(() =>
                    {
                        TabsHideAll_p67();
                        TabShow_p67(tab);
                        foreach (var tab2 in tabs_p67)
                        {
                            tabsButtons_p67[tab2].buttonColor = X.colorworks_p67.GetColorMidPurple_p67();
                        }
                        tabsButtons_p67[tab].buttonColor = X.colorworks_p67.GetColorDeepPurple_p67();
                    });
              
            }





            X.sliders_p67.Add("touchdetection_tease", new JSONStorableFloat("Tease treshold", 0.05f, 0f, 2f, false, true));
            X.sliders_p67.Add("touchdetection_caress", new JSONStorableFloat("Caress treshold", 0.20f, 0f, 2f, false, true));
            X.sliders_p67.Add("touchdetection_spank", new JSONStorableFloat("Spank treshold", 0.60f, 0f, 2f, false, true));




            foreach (var feature in X.areas_p67)
            {
                X.enableFeatures_p67[feature] = new JSONStorableBool("Enable " + feature, true);
   
                //  CreateToggle(enableFeatures_p67[feature], true);

                X.myEventTriggers_p67.Add("ontease" + feature, new EventTrigger(X, "TriggerOnTeaseUpdate" + feature));
                X.myEventTriggers_p67.Add("oncaress" + feature, new EventTrigger(X, "TriggerOnCaressUpdate" + feature));
                X.myEventTriggers_p67.Add("onspank" + feature, new EventTrigger(X, "TriggerOnSpankUpdate" + feature));

                if (!X.buttons_p67.ContainsKey("ontease" + feature)) X.buttons_p67.Add("ontease" + feature, null);
                if (!X.buttons_p67.ContainsKey("oncaress" + feature)) X.buttons_p67.Add("oncaress" + feature, null);
                if (!X.buttons_p67.ContainsKey("onspank" + feature)) X.buttons_p67.Add("onspank" + feature, null);


                // buttons_p67["ontrigger" + feature] = SPQRUtils.CreateButton_p67(X, "On trigger " + feature, myEventTriggers_p67[feature].OpenPanel, true);

                //  if (!buttons_p67.ContainsKey("ontriggertest" + feature)) buttons_p67.Add("ontriggertest" + feature, null);
                // buttons_p67["ontriggertest"+feature] = SPQRUtils.CreateButton_p67(X, "Test trigger", myEventTriggers_p67[feature].Trigger, true);


            }

            foreach (var str in X.strings_p67)
            {
                X.strings_p67[str.Key].storeType = JSONStorableParam.StoreType.Full;
                X.RegisterString(X.strings_p67[str.Key]);
            }




            foreach (var item in X.playergazeworks_p67.lookAtCooldowns_p67)
            {
                var itemname = item.Key;
                X.myEventTriggers_p67.Add("onGlance" + itemname, new EventTrigger(X, "TriggerOnGlance"+itemname));

                X.myEventTriggers_p67.Add("onGaze" + itemname, new EventTrigger(X, "TriggerOnGaze" + itemname));

                X.myEventTriggers_p67.Add("onStare" + itemname, new EventTrigger(X, "TriggerOnStare" + itemname));
            }




            foreach (var enableitem in X.enableFeatures_p67)
            {
                enableitem.Value.storeType = JSONStorableParam.StoreType.Full;
                X.RegisterBool(enableitem.Value);
            }


            foreach (var slideritem in X.sliders_p67)
            {
                slideritem.Value.storeType = JSONStorableParam.StoreType.Full;
                X.RegisterFloat(slideritem.Value);
            }

        }

         public void generalForceScaleJSONUpdate_p67(JSONStorableFloat jf)
        {

        }




        public void TabsHideAll_p67()
        {
            tabsToggleTouchDetection_p67(false);
            tabsToggleTriggers_p67(false);
            tabsToggleStareTriggers_p67(false);
            tabsToggleStatusTriggers_p67(false);
            tabsTogglePresets_p67(false);
        }

      
       

        private void tabsToggleTouchDetection_p67(bool show)
        {
            if (show)
            {
                X.CreateSlider(X.sliders_p67["touchdetection_tease"], true);
                X.CreateSlider(X.sliders_p67["touchdetection_caress"], true);
                X.CreateSlider(X.sliders_p67["touchdetection_spank"], true);

               
                

                X.CreateToggle(X.collisionsLogBool_p67, true);
                UIDynamicTextField dtext3 = X.CreateTextField(X.collisionsLog_p67, true);
                dtext3.UItext.supportRichText = true;
                dtext3.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
                dtext3.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext3.height = 600f;


                // CreateSlider(X.sliders_p67["treshold1"],true);
                // CreateSlider(X.sliders_p67["treshold2"],true);
                // CreateSlider(X.sliders_p67["cooldown"],true);
            }
            else
            {
                if (X.sliders_p67.ContainsKey("touchdetection_tease")) X.RemoveSlider(X.sliders_p67["touchdetection_tease"]);
                if (X.sliders_p67.ContainsKey("touchdetection_caress")) X.RemoveSlider(X.sliders_p67["touchdetection_caress"]);
                if (X.sliders_p67.ContainsKey("touchdetection_spank")) X.RemoveSlider(X.sliders_p67["touchdetection_spank"]);

                

                // if (X.sliders_p67.ContainsKey("treshold1")) RemoveSlider(X.sliders_p67["treshold1"]);
                // if (X.sliders_p67.ContainsKey("treshold2")) RemoveSlider(X.sliders_p67["treshold2"]);
                // if (X.sliders_p67.ContainsKey("cooldown")) RemoveSlider(X.sliders_p67["cooldown"]);

                X.RemoveToggle(X.collisionsLogBool_p67);
                X.RemoveTextField(X.collisionsLog_p67);



            }

        }

        private void tabsToggleStatusTriggers_p67(bool show)
        {
            if (show)
            {
                UIDynamicTextField dtext3 = X.CreateTextField(X.AliveStatus_p67, true);
                dtext3.UItext.supportRichText = true;
                dtext3.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
                dtext3.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext3.height = 200f;

                foreach (var area in X.tickletriggers_p67)
                {
                    if (!X.buttons_p67.ContainsKey("ontease" + area)) X.buttons_p67.Add("ontease" + area, null);
                    X.buttons_p67["ontease" + area] = SPQRUtils.CreateButton_p67(X, "On Tease " + area, X.myEventTriggers_p67["ontease" + area].OpenPanel, true);
                    if (!X.buttons_p67.ContainsKey("oncaress" + area)) X.buttons_p67.Add("oncaress" + area, null);
                    X.buttons_p67["oncaress" + area] = SPQRUtils.CreateButton_p67(X, "On Arouse " + area, X.myEventTriggers_p67["oncaress" + area].OpenPanel, true);
                    if (!X.buttons_p67.ContainsKey("onspank" + area)) X.buttons_p67.Add("onspank" + area, null);
                    X.buttons_p67["onspank" + area] = SPQRUtils.CreateButton_p67(X, "On Discomfort " + area, X.myEventTriggers_p67["onspank" + area].OpenPanel, true);

                }

            }
            else
            {

                X.RemoveTextField(X.AliveStatus_p67);
                foreach (var area in X.tickletriggers_p67)
                {
                    if (X.buttons_p67.ContainsKey("ontease" + area)) X.RemoveButton(X.buttons_p67["ontease" + area]);
                    if (X.buttons_p67.ContainsKey("oncaress" + area)) X.RemoveButton(X.buttons_p67["oncaress" + area]);
                    if (X.buttons_p67.ContainsKey("onspank" + area)) X.RemoveButton(X.buttons_p67["onspank" + area]);
                }
            }
        }

        private void tabsTogglePresets_p67(bool show)
        {

            if (show)
            {
                // X.buttons_p67["load_defaults"] = CreateButton_p67("Load Default", true);
                // X.buttons_p67["load_defaults"].button.onClick.AddListener(() =>
                // {
                //     var jc = new JSONClass();
                //     base.RestoreFromJSON(jc);
                //     foreach (var area in areas_p67)
                //     {
                //         X.myEventTriggers_p67["ontease"+area].RestoreFromJSON(jc, base.subScenePrefix,false, true);
                //         X.myEventTriggers_p67["oncaress"+area].RestoreFromJSON(jc, base.subScenePrefix,false, true);
                //         X.myEventTriggers_p67["onspank"+area].RestoreFromJSON(jc, base.subScenePrefix,false, true);
                //     }
                //     foreach (var area2 in tickletriggers_p67)
                //     {
                //         X.myEventTriggers_p67["ontease"+area2].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                //         X.myEventTriggers_p67["oncaress"+area2].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                //         X.myEventTriggers_p67["onspank"+area2].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                //     }
                // });
                X.buttons_p67["load_preset"] = X.CreateButton("Load Preset", true);
                X.buttons_p67["load_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(X.SavePath_p67);
                    var shortcuts = FileManagerSecure.GetShortCutsForDirectory(X.SavePath_p67);
                    SuperController.singleton.GetMediaPathDialog(X.HandleLoadPreset_p67, X.SaveExtension_p67, X.SavePath_p67, false, true, false, null, false, shortcuts);
                });

                X.buttons_p67["save_preset"] = X.CreateButton("Save Preset", true);
                X.buttons_p67["save_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(X.SavePath_p67);
                    var fileBrowserUI = SuperController.singleton.fileBrowserUI;
                    fileBrowserUI.SetTitle("Save Preset");
                    fileBrowserUI.fileRemovePrefix = null;
                    fileBrowserUI.hideExtension = true;
                    fileBrowserUI.keepOpen = false;
                    fileBrowserUI.canCancel = true;
                    fileBrowserUI.fileFormat = X.SaveExtension_p67;
                    fileBrowserUI.defaultPath = X.SavePath_p67;
                    fileBrowserUI.showDirs = true;
                    fileBrowserUI.showFiles = true;
                    fileBrowserUI.shortCuts = null;
                    fileBrowserUI.browseVarFilesAsDirectories = false;
                    fileBrowserUI.SetTextEntry(true);
                    fileBrowserUI.Show(X.HandleSavePreset_p67);
                    fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + X.SaveExtension_p67;
                    fileBrowserUI.ActivateFileNameField();

                });
            }
            else
            {
                if (X.buttons_p67.ContainsKey("save_preset"))
                    X.RemoveButton(X.buttons_p67["save_preset"]);
                if (X.buttons_p67.ContainsKey("load_preset"))
                    X.RemoveButton(X.buttons_p67["load_preset"]);
                // if (X.buttons_p67.ContainsKey("load_defaults"))
                //     RemoveButton(X.buttons_p67["load_defaults"]);
            }
        }
        
        private void tabsToggleStareTriggers_p67(bool show)
        {
            if (show)
            {

                foreach (var item in X.playergazeworks_p67.lookAtCooldowns_p67)
                {
                    var itemname = item.Key;
                    if (!X.buttons_p67.ContainsKey("onGlance" + itemname)) X.buttons_p67.Add("onGlance" + itemname, null);
                    X.buttons_p67["onGlance" + itemname] = SPQRUtils.CreateButton_p67(X, "On Glance " + itemname, X.myEventTriggers_p67["onGlance" + itemname].OpenPanel, true);
                    if (!X.buttons_p67.ContainsKey("onGaze" + itemname)) X.buttons_p67.Add("onGaze" + itemname, null);
                    X.buttons_p67["onGaze" + itemname] = SPQRUtils.CreateButton_p67(X, "On Gaze " + itemname, X.myEventTriggers_p67["onGaze" + itemname].OpenPanel, true);
                    if (!X.buttons_p67.ContainsKey("onStare" + itemname)) X.buttons_p67.Add("onStare" + itemname, null);
                    X.buttons_p67["onStare" + itemname] = SPQRUtils.CreateButton_p67(X, "On Stare " + itemname, X.myEventTriggers_p67["onStare" + itemname].OpenPanel, true);
                }


            }
            else
            {
                foreach (var item in X.playergazeworks_p67.lookAtCooldowns_p67)
                {
                    var itemname = item.Key;
                    if (X.buttons_p67.ContainsKey("onGlance" + itemname)) X.RemoveButton(X.buttons_p67["onGlance" + itemname]);
                    if (X.buttons_p67.ContainsKey("onGaze" + itemname)) X.RemoveButton(X.buttons_p67["onGaze" + itemname]);
                    if (X.buttons_p67.ContainsKey("onStare" + itemname)) X.RemoveButton(X.buttons_p67["onStare" + itemname]);
                }
            }
        }

        private void tabsToggleTriggers_p67(bool show)
        {
            if (show)
            {
                foreach (var area in X.areas_p67)
                {
                    if (!X.buttons_p67.ContainsKey("ontease" + area)) X.buttons_p67.Add("ontease" + area, null);
                    X.buttons_p67["ontease" + area] = SPQRUtils.CreateButton_p67(X, "On tease " + area, X.myEventTriggers_p67["ontease" + area].OpenPanel, true);

                    if (!X.buttons_p67.ContainsKey("oncaress" + area)) X.buttons_p67.Add("oncaress" + area, null);
                    X.buttons_p67["oncaress" + area] = SPQRUtils.CreateButton_p67(X, "On caress " + area, X.myEventTriggers_p67["oncaress" + area].OpenPanel, true);

                    if (!X.buttons_p67.ContainsKey("onspank" + area)) X.buttons_p67.Add("onspank" + area, null);
                    X.buttons_p67["onspank" + area] = SPQRUtils.CreateButton_p67(X, "On spank " + area, X.myEventTriggers_p67["onspank" + area].OpenPanel, true);


                    // if (!X.buttons_p67.ContainsKey("ontriggertest" + area)) X.buttons_p67.Add("ontriggertest" + area, null);
                    // X.buttons_p67["ontriggertest"+area] = SPQRUtils.CreateButton_p67(X, "Test trigger", X.myEventTriggers_p67[area].Trigger, true);
                }
            }
            else
            {
                foreach (var area in X.areas_p67)
                {
                    if (X.buttons_p67.ContainsKey("ontease" + area)) X.RemoveButton(X.buttons_p67["ontease" + area]);
                    if (X.buttons_p67.ContainsKey("oncaress" + area)) X.RemoveButton(X.buttons_p67["oncaress" + area]);
                    if (X.buttons_p67.ContainsKey("onspank" + area)) X.RemoveButton(X.buttons_p67["onspank" + area]);
                }
            }
        }


        private void TabShow_p67(string tab)
        {
            try
            {
                tabsBool_p67[tab] = true;
                switch (tab)
                {

                    case "Touch Detection": tabsToggleTouchDetection_p67(true); break;
                    case "Stare Triggers": tabsToggleStareTriggers_p67(true); break;
                    case "Touch Triggers": tabsToggleTriggers_p67(true); break;
                    case "Status Triggers": tabsToggleStatusTriggers_p67(true); break;
                    case "Presets": tabsTogglePresets_p67(true); break;


                }
            }
            catch (Exception e)
            {
                //   SuperController.LogError("Exception caught: " + e);
            }


        }




        public UIDynamicButton CreateTabButton_p67(string label, bool rightSide = false)
        {
            UIDynamicButton uIDynamicButton = null;
            if (X.manager != null && X.manager.configurableButtonPrefab != null)
            {
                Transform transform = X.getUITransform_p67(rightSide);
                if (transform != null)
                {

                    uIDynamicButton = transform.GetComponent<UIDynamicButton>();
                    if (uIDynamicButton != null)
                    {
                        uIDynamicButton.label = label;
                        uIDynamicButton.buttonColor = X.colorworks_p67.GetColorMidPurple_p67();
                        uIDynamicButton.textColor = X.colorworks_p67.GetColorLight_p67();
                    }
                }
            }
            return uIDynamicButton;
        }

      
    }







}